#include "mainwindow.h"
#include "ui_mainwindow.h"

const int N = 8;
int a [N][N];
MainWindow * win = NULL;

QColor color (int i, int j)
{
    if ( (i+j) % 2 == 0 )
        return QColor ("white");
    else
        return QColor ("green");
}

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    win = this; // zapamatovat si okno

    ui->table->setColumnCount (N);
    ui->table->setRowCount (N);

    int h = ui->table->rowHeight (0);
    for (int i = 0; i < N; i++)
        ui->table->setColumnWidth (i, h);

    for (int i = 0; i < N; i++)
        for (int j = 0; j < N; j++)
        {
            QTableWidgetItem * p = new QTableWidgetItem;
            p->setText ("");
            p->setBackgroundColor(color(i,j));
            ui->table->setItem(i, j, p);
        }
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_table_cellClicked(int row, int column)
{
    int i = row;
    int j = column;
    QTableWidgetItem * p = ui->table->item (i, j); // nikoliv itemAt
    if (p->text() == "-1")
    {
        p->setText ("");
        p->setBackgroundColor(color(i,j));
    }
    else
    {
        p->setText ("-1");
        p->setBackgroundColor(QColor ("red"));
    }

}

void MainWindow::showResult ()
{
    QTableWidget * t = new QTableWidget (); // nova sachovnice

    t->setColumnCount (N);
    t->setRowCount (N);

    int h = t->rowHeight (0);
    for (int i = 0; i < N; i++)
        t->setColumnWidth (i, h);

    for (int i = 0; i < N; i++)
        for (int j = 0; j < N; j++)
        {
            QTableWidgetItem * p = new QTableWidgetItem;
            if (a[i][j] == 0)
            {
               p->setText ("");
               p->setBackgroundColor(color(i,j));
            }
            else if (a[i][j] == -1)
            {
                p->setText ("-1");
                p->setBackgroundColor(QColor ("red"));
            }
            else
            {
                p->setText (QString::number (a[i][j]));
                p->setBackgroundColor(QColor ("yellow"));
            }

            ui->table->setItem(i, j, p);
        }

    ui->results->addTab  (t, "  ");
}

void move (int & i, int & j)
{
    if (j < N-1)
        j ++; // posun dolu ve sloupci
    else
    {
        j = 0; // nulta (prvni) (horni) radka
        i ++ ; // dalsi sloupec
        // na konci "prelezeme" na N-ty (n+1-ni) sloupec
    }
}

void test (int i, int j, /* pozice nove damy */
           int dx, int dy, /* smer postupu */
           bool & ok /* zda byla kolize, prirazujeme jen false */ )
{
    i += dx;
    j += dy; // jeden krok
    while (ok && 0 <= i && i <= N-1 && 0<=j && j <= N-1)
        // dokud nebyla kolize a jsme na sachovnici
    {
        if (a[i][j] > 0 ) ok = false; // potkali jsem damu
        if (a[i][j] < 0) break; // narazili jsme na prekazku

        i += dx;
        j += dy; // dalsi krok

    }
}


void place (int inx /* cislo damy (od 1 do N) */,
            int i /* cislo radky (od 0 do N-1) */,
            int j /* cislo sloupce, od kteho umistujeme damu */ )
{
    while (i < N && j < N)// dokud jsme na sachovnici
    {
        if (a[i][j] == 0) // pokud neni prekazka
        {

           // zkusime, zda damu na i, j nekoliduje
           bool ok = true; // ok .. zda byla kolize, jsme optimiste

           test (i, j, 0, -1, ok); // zkus cestu nahoru
           test (i, j, -1, 0, ok); // zkus cestu vlevo
           test (i, j, -1, -1, ok); // zkus cestu vlevo nahoru
           test (i, j, -1, 1, ok); // zkus cestu vlevo dolu
           // podemnou a vpravo jeste nic neni

           if (ok) // nebyla kolize, umistime dalsi damu)
           {
              a[i][j] = inx; // umistime nasi damu na i, j

              int ti = i;
              int tj = j;
              move (ti, tj); // ti, tj pozice pro dalsi damu

              if (inx < N && ti < N && tj < N)
                  // zbyva jeste nejaka dama a jeste jsme na sachovnici
                  place (inx +1, ti, tj) ; // zkusime umistit dalsi damu

              if (inx == N)
              {
                  // N dam je umisteno, nalezli jsem vysledek
                  win->showResult ();
              }

              a[i][j] = 0; // nasi damu odstranime
           }
        }

        // zkusit novou pozici
        move (i, j);
    }
}

void MainWindow::on_pushButton_clicked()
{
    // z tabulky do pole a
    for (int i = 0; i < N; i++)
        for (int j = 0; j < N; j++)
        {
            QTableWidgetItem * p = ui->table->item (i, j); // nikoliv itemAt
            if (p->text() == "-1")
                a[i][j] = -1; // prekazka
            else
                a[i][j] = 0; // colkoliv jineho povazujeme za volne policko
        }


    // musi mit vyplnene pole a
    place (1, 0, 0); // prvni damu na 0, 0
}

